UNIT mTDEA;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mtzustand, Dialogs;

type
   TDEA = CLASS

     // weitere Attribute
     private
        aktuellerZustand : TZustand;
        FehlerZustand : TZustand;
        startZustand : TZustand;

     //Objektbeziehungen:
        // kenntTZustand1, // kenntTZustand2 : TZustand;

     // weitere Methoden
     private
        function ausgabeFunktion (pStartZustand: TZustand; pEingabe: String) : String; virtual;
        function uebergangsFunktion (pStartZustand: TZustand; pEingabe: String) : TZustand; virtual;
     public
        constructor init (pStartZustand: TZustand);
        procedure setzeAutomatenZurueck;
        procedure setzeFehlerZustand (pFehlerZustand: TZustand);
        function gibAktuellenZustand : TZustand; virtual;
        function istInAkzeptiertemZustand : Boolean; virtual;
        function istInFehlerZustand : Boolean;
        function verarbeiteEingabe (pEingabe: String) : String; virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TDEA: Methodendefinition 
//+---------------------------------------------------------------------

//-------- ausgabeFunktion (private) -----------------------------------
function TDEA.ausgabeFunktion (pStartZustand: TZustand; pEingabe: String) : String;
begin
  result := pStartZustand.AusgabeNachEingabe(pEingabe);
end;

//-------- uebergangsFunktion (private) --------------------------------
function TDEA.uebergangsFunktion (pStartZustand: TZustand; pEingabe: String) : TZustand;
begin
  result := pStartZustand.ZustandNachEingabe(pEingabe);
end;

//-------- init (public) -----------------------------------------------
constructor TDEA.init (pStartZustand: TZustand);
begin
  FehlerZustand := NIL;
  startZustand := pStartZustand;
  setzeAutomatenZurueck;
end;

//-------- setzeAutomatenZurueck (public) ------------------------------
procedure TDEA.setzeAutomatenZurueck;
begin
  aktuellerZustand := StartZustand;
end;

//-------- setzeFehlerZustand (public) ---------------------------------
procedure TDEA.setzeFehlerZustand (pFehlerZustand: TZustand);
begin
  FehlerZustand := pFehlerZustand;
end;

//-------- gibAktuellenZustand (public) --------------------------------
function TDEA.gibAktuellenZustand : TZustand;
begin
  result := aktuellerZustand;
end;

//-------- istInAkzeptiertemZustand (public) ---------------------------
function TDEA.istInAkzeptiertemZustand : Boolean;
begin
  result := aktuellerZustand.GibIstAkzeptiert;
end;

//-------- istInFehlerZustand (public) ---------------------------------
function TDEA.istInFehlerZustand : Boolean;
begin
  result := (aktuellerZustand = FehlerZustand);
end;

//-------- verarbeiteEingabe (public) ----------------------------------
function TDEA.verarbeiteEingabe (pEingabe: String) : String;
var
  tmpZustand : TZustand;
begin
  tmpZustand := UebergangsFunktion(aktuellerZustand, pEingabe);
  result := ausgabeFunktion(aktuellerZustand, pEingabe);

  if tmpZustand = NIL then
  begin
    if FehlerZustand <> NIL
      then aktuellerZustand := FehlerZustand;
  end
    else aktuellerZustand := tmpZustand;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TDEA.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
