UNIT mTZustand;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTAVLSuchBaum, dialogs, mtbinbaum;

type
   TZustand = CLASS

     // weitere Attribute
     private
        istAkzeptiert : Boolean;
        Name : String;
        moeglicheEingaben : TAVLSuchBaum;

     //Objektbeziehungen:
        // kenntTDEA () of TDEA;
        // kenntTEingabePaar (0..n) of TEingabePaar;

     // weitere Methoden
     public
        constructor init (pName: String); virtual;
        procedure entferneAlleEingaben; virtual;
        procedure FuegeEingabeHinzu (pEingabe: String; pZielZustand: TZustand; pAusgabe: String);
        procedure SetzeIstAkzeptiert (pIstAkzeptiert: Boolean); virtual;
        procedure SetzeName (pName: String); virtual;
        function AusgabeNachEingabe (pEingabe: String) : String; virtual;
        function GibIstAkzeptiert : Boolean; virtual;
        function gibName : String; virtual;
        function ZustandNachEingabe (pEingabe: String) : TZustand; virtual;
        destructor gibFrei; virtual;

   end;

implementation

uses mTEingabePaar;

//+---------------------------------------------------------------------
//|         TZustand: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TZustand.init (pName: String);
begin
  name := pName;
  istAkzeptiert := false;
  moeglicheEingaben := TAVLSuchBaum.init(NIL);
end;

//-------- entferneAlleEingaben (public) -------------------------------
procedure TZustand.entferneAlleEingaben;
begin
  moeglicheEingaben.GibFrei;
  moeglicheEingaben := TAVLSuchBaum.init(NIL);  
end;

//-------- FuegeEingabeHinzu (public) ----------------------------------
procedure TZustand.FuegeEingabeHinzu (pEingabe: String; pZielZustand: TZustand; pAusgabe: String);
begin
  moeglicheEingaben.fuegeObjectEinAVL(TEingabePaar.init(pEingabe, pZielZustand, pAusgabe));
end;

//-------- SetzeIstAkzeptiert (public) ---------------------------------
procedure TZustand.SetzeIstAkzeptiert (pIstAkzeptiert: Boolean);
   begin
      istAkzeptiert := pIstAkzeptiert
   end;

//-------- SetzeName (public) ------------------------------------------
procedure TZustand.SetzeName (pName: String);
   begin
      Name := pName
   end;

//-------- AusgabeNachEingabe (public) ---------------------------------
function TZustand.AusgabeNachEingabe (pEingabe: String) : String;
var
  tmpBaum : TBinBaum;
  suchPaar : TEingabePaar;
begin
  result := '';
  suchPaar := TEingabePaar.init(pEingabe, NIL, '');
  tmpBaum := moeglicheEingaben.gibBaumMitInhalt(suchPaar);
  suchPaar.gibFrei;
  if tmpBaum <> NIL
    then result := (tmpBaum.gibInhalt as TEingabePaar).GibAusgabe
end;

//-------- GibIstAkzeptiert (public) -----------------------------------
function TZustand.GibIstAkzeptiert : Boolean;
   begin
      result  := istAkzeptiert
   end;

//-------- gibName (public) --------------------------------------------
function TZustand.gibName : String;
   begin
      result  := Name
   end;

//-------- ZustandNachEingabe (public) ---------------------------------
function TZustand.ZustandNachEingabe (pEingabe: String) : TZustand;
var
  tmpBaum : TBinBaum;
  suchPaar : TEingabePaar;
begin
  result := NIL;
  suchPaar := TEingabePaar.init(pEingabe, NIL, '');
  tmpBaum := moeglicheEingaben.gibBaumMitInhalt(suchPaar);
  suchPaar.gibFrei;
  if tmpBaum <> NIL
    then result := (tmpBaum.gibInhalt as TEingabePaar).gibZielZustand;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TZustand.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
